#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <errno.h>
#include <signal.h>
#include <stdio.h>
#include <sys/wait.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <sys/os16.h>
//----------------------------------------------------------------------
static void usage (void);
//----------------------------------------------------------------------
int
main (int argc, char *argv[], char *envp[])
{
    int     status;
    mode_t  mode;
    char   *m;          // Pointer inside the octal mode string.
    int     digit;
    int     a;          // Argument index.
    //
    //
    //
    if (argc < 3)
      {
        usage ();
        return (1);
      }
    //
    // Get mode: must be the first argument.
    //
    for (m = argv[1]; *m != 0; m++)
      {
        digit = (*m - '0');
        if (digit < 0 || digit > 7)
          {
            usage ();
            return (2);
          }
        mode = mode * 8 + digit;
      }
    //
    // System call for all the remaining arguments.
    //
    for (a = 2; a < argc; a++)
      {
        status = chmod (argv[a], mode);
        if (status != 0)
          {
            perror (argv[a]);
            return (3);
          }
      }
    //
    // All done.
    //
    return (0);
}
//----------------------------------------------------------------------
static void
usage (void)
{
    fprintf (stderr, "Usage:   chmod OCTAL_MODE FILE...\n");
    fprintf (stderr, "Example: chmod 0640 my_file\n");
}
