#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>
#include <signal.h>
#include <stdio.h>
#include <sys/wait.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <stdint.h>
#include <sys/os16.h>
//----------------------------------------------------------------------
#define LOGIN_MAX       64
#define PASSWORD_MAX    64
#define HOME_MAX        64
#define LINE_MAX        1024
//----------------------------------------------------------------------
int
main (int argc, char *argv[], char *envp[])
{
    char    login[LOGIN_MAX];
    char    password[PASSWORD_MAX];
    char    buffer[LINE_MAX];
    char   *user_name;
    char   *user_password;
    char   *user_uid;
    char   *user_gid;
    char   *user_description;
    char   *user_home;
    char   *user_shell;
    uid_t   uid;
    uid_t   euid;
    int     fd;
    ssize_t size_read;
    int     b;          // Index inside buffer.
    int     loop;
    char   *exec_argv[2];
    int     status;
    char   *tty_path;
    //
    // Check if login is running correctly.
    //
    euid = geteuid ();
    uid  = geteuid ();
    //  //
    //  // Show process info.
    //  //
    //  heap_clear ();
    //  process_info ();
    //
    // Check privileges.
    //
    if (!(uid == 0 && euid == 0))
      {
        printf ("%s: can only run with root privileges!\n", argv[0]);
        exit (-1);
      }
    //
    // Prepare arguments for the shell call.
    //
    exec_argv[0] = "-";
    exec_argv[1] = NULL;
    //
    // Login.
    //
    while (1)
      {
        fd = open ("/etc/passwd", O_RDONLY);
        //
        if (fd < 0)
          {
            perror ("Cannot open file `/etc/passwd'");
            exit (-1);
          }
        //
        printf ("Log in as \"root\" or \"user\" "
                "with password \"ciao\" :-)\n");
        input_line (login, "login:", LOGIN_MAX, INPUT_LINE_ECHO);
        //
        //
        //
        loop = 1;
        while (loop)
          {
            for (b = 0; b < LINE_MAX; b++)
              {
                size_read = read (fd, &buffer[b], (size_t) 1);
                if (size_read <= 0)
                  {
                    buffer[b] = 0;
                    loop = 0;           // Close the middle loop.
                    break;
                  }
                if (buffer[b] == '\n')
                  {
                    buffer[b] = 0;
                    break;
                  }
              }
            //
            user_name        = strtok (buffer, ":");
            user_password    = strtok (NULL, ":");
            user_uid         = strtok (NULL, ":");
            user_gid         = strtok (NULL, ":");
            user_description = strtok (NULL, ":");
            user_home        = strtok (NULL, ":");
            user_shell       = strtok (NULL, ":");
            //
            if (strcmp (user_name, login) == 0)
              {
                input_line (password, "password:", PASSWORD_MAX,
                            INPUT_LINE_STARS);
                //
                // Compare passwords: empty passwords are not allowed.
                //
                if (strcmp (user_password, password) == 0)
                  {
                    uid  = atoi (user_uid);
                    euid = uid;
                    //
                    // Find the controlling terminal and change
                    // property and access permissions.
                    //
                    tty_path = ttyname (STDIN_FILENO);
                    if (tty_path != NULL)
                      {
	                status = chown (tty_path, uid, 0);
			if (status != 0)
			  {
	    	    	    perror (NULL);
			  }
	                status = chmod (tty_path, 0600);
			if (status != 0)
			  {
	    	    	    perror (NULL);
			  }
	              }
		    //
		    // Cd to the home directory, if present.
		    //
		    status = chdir (user_home);
		    if (status != 0)
		      {
	    	        perror (NULL);
		      }
                    //
                    // Now change personality.
                    //
                    setuid (uid);
                    seteuid (euid);
                    //
                    // Run the shell, replacing the login process; the
                    // environment is taken from `init'.
                    //
                    execve (user_shell, exec_argv, envp);
                    exit (0);
                  }
                //
                // Login failed: will try again.
                //
                loop = 0;               // Close the middle loop.
                break;
              }
          }
        close (fd);
      }
}
