#include <fcntl.h>
#include <sys/stat.h>
#include <utime.h>
#include <stddef.h>
#include <unistd.h>
#include <errno.h>
//----------------------------------------------------------------------
static void usage (void);
//----------------------------------------------------------------------
int
main (int argc, char *argv[], char *envp[])
{
    int         a;              // Argument index.
    int         status;
    struct stat file_status;
    //
    // No options are known, but at least an argument must be given.
    //
    if (argc < 2)
      {
        usage ();
        return (1);
      }
    //
    // Scan arguments.
    //
    for(a = 1; a < argc; a++)
      {
        //
        // Verify if the file exists, through the return value of
        // `stat()'. No other checks are made.
        //
        if (stat(argv[a], &file_status) == 0)
         {
            //
            // File exists: should be updated the times.
            //
            status = utime (argv[a], NULL);
            if (status != 0)
              {
                perror (NULL);
                return (2);
              }
          }
        else
          {
            //
            // File does not exist: should be created.
            //
            status = open (argv[a], O_WRONLY|O_CREAT|O_TRUNC, 0666);
            //
            if (status >= 0)
              {
                //
                // Here, the variable `status' is the file
                // descriptor to be closed.
                //
                status = close (status);
                if (status != 0)
                  {
                    perror (NULL);
                    return (3);
                  }
              }
            else
              {
                perror (NULL);
                return (4);
              }
          }
      }
    return (0);
}
//----------------------------------------------------------------------
static void
usage (void)
{
    fprintf (stderr, "Usage: touch FILE...\n");
}
