#include <kernel/fs.h>
#include <errno.h>
#include <kernel/proc.h>
//----------------------------------------------------------------------
int
path_full (const char *path, const char *path_cwd, char *full_path)
{
    unsigned int path_size;
    //
    // Check some arguments.
    //
    if (path == NULL || strlen (path) == 0 || full_path == NULL)
      {
        errset (EINVAL);                // Invalid argument.
        return (-1);
      }
    //
    // The main path and the receiving one are right.
    // Now arrange to get a full path name.
    //
    if (path[0] == '/')
      {
        strncpy (full_path, path, PATH_MAX);
        full_path[PATH_MAX-1] = 0;
      }
    else
      {
        if (path_cwd == NULL || strlen (path_cwd) == 0)
          {
            errset (EINVAL);            // Invalid argument.
            return (-1);
          }
        strncpy (full_path, path_cwd, PATH_MAX);
        path_size = strlen (full_path);
        strncat (full_path, "/", (PATH_MAX - path_size));
        path_size = strlen (full_path);
        strncat (full_path, path, (PATH_MAX - path_size));
      }
    //
    // Fix path name so that it has no `..', `.', and no
    // multiple `/'.
    //
    path_fix (full_path);
    //
    // Return.
    //
    return (0);
}
