.global __int13_00
;-----------------------------------------------------------------------
.text
;-----------------------------------------------------------------------
; INT 0x13 - disk - reset disk system
;       AH = 0x00
;       DL = drive (if bit 7 is set both hard disks and floppy disks
;            reset)
; Return:
;       AH = status
;       CF clear if successful (returned AH=0x00)
;       CF set on error
;-----------------------------------------------------------------------
.align 2
__int13_00:
    enter #2, #0        ; 1 local variable.
    pushf
    cli
    pusha
    mov   ah, #0x00
    mov   dl, 4[bp]     ; 1st arg.
    int   #0x13
    mov   al, #0x00
    mov   -2[bp], ax    ; save AX.
    popa
    popf
    mov   ax, -2[bp]    ; AX is the function return value.
    leave
    ret
