.global __int16_02
;-----------------------------------------------------------------------
.text
;-----------------------------------------------------------------------
; INT 0x16 - keyboard - get shift flags
;       AH = 0x02
; Return:
;       AL = shift flags
;       AH might be destroyed
;
; bit 7    Insert active
; bit 6    CapsLock active
; bit 5    NumLock active
; bit 4    ScrollLock active
; bit 3    Alt key pressed
; bit 2    Ctrl key pressed
; bit 1    left shift key pressed
; bit 0    right shift key pressed
;-----------------------------------------------------------------------
.align 2
__int16_02:
    enter #2, #0        ; 1 local variable.
    pushf
    cli
    pusha
    mov   ah, #0x02
    int   #0x16
    mov   ah, #0        ; Reset AH.
    mov   -2[bp], ax    ; Save AX.
    popa
    popf
    mov   ax, -2[bp]    ; AX is the function return value.
    leave
    ret
