#include <kernel/ibm_i86.h>
#include <kernel/k_libc.h>
#include <sys/os16.h>
#include <sys/types.h>
#include <stdint.h>
//----------------------------------------------------------------------
int
dsk_write_sectors (int drive, unsigned int start_sector, void *buffer,
                   unsigned int n_sectors)
{
    int          status;
    unsigned int retry;
    unsigned int remaining;
    dsk_chs_t    chs;
    dsk_sector_to_chs (drive, start_sector, &chs);
    remaining = dsk_table[drive].sectors - chs.sector + 1;
    if (remaining < n_sectors)
      {
        status = dsk_write_sectors (drive, start_sector,
                                    buffer, remaining);
        if (status == 0)
          {
            status = dsk_write_sectors (drive,
                                        start_sector + remaining,
                                        buffer, n_sectors - remaining);
          }
        return (status);
      }
    else
      {
        for (retry = 0; retry < dsk_table[drive].retry; retry++)
          {
            status = int13_03 (dsk_table[drive].bios_drive, n_sectors,
                               chs.cylinder, chs.head, chs.sector,
                               buffer);
            status = status & 0x00F0;
            if (status == 0)
              {
                break;
              }
            else
              {
                dsk_reset (drive);
              }
          }
      }
    if (status == 0)
      {
        return (0);
      }
    else
      {
        return (-1);
      }
}
