#ifndef _KERNEL_K_LIBC_H
#define _KERNEL_K_LIBC_H       1

#include <const.h>
#include <restrict.h>
#include <size_t.h>
#include <clock_t.h>
#include <time_t.h>
#include <sys/types.h>
#include <stdarg.h>

//----------------------------------------------------------------------
void    k_exit     (int status);
//----------------------------------------------------------------------
clock_t k_clock    (void);
int     k_stime    (time_t *timer);
time_t  k_time     (time_t *timer);
//----------------------------------------------------------------------
int     k_puts     (const char *string);
int     k_printf   (const char *restrict format, ...);
int     k_vprintf  (const char *restrict format, va_list arg);
int     k_vsprintf (char *restrict string, const char *restrict format,
                    va_list arg);
void    k_perror   (const char *s);

int     k_kill     (pid_t pid, int sig);
int     k_open     (const char *file, int oflags, ...);
void    k_close    (int fd);
ssize_t k_read     (int fd, void *buffer, size_t count);
//----------------------------------------------------------------------

#endif
